import c4d
import re
from c4d import gui

#Welcome to the world of Python

def AimAxis(pos, aim_pos, aim_axis, up_pos, up_axis):
    axis = (aim_axis, up_axis)
    axis_pos = (aim_pos, up_pos)
    new_Ml = c4d.Matrix()
    new_Ml.off = pos

    for i in axis:
        if re.search(r"\A[-+]{,1}[xyz]\Z", i) == None: 
            print "String '{0}' wird nicht verstanden".format(i)
            return None
        if re.search(r"\A-[xyz]\Z", i) != None:
            if i == axis[0]: aim_vec = -(aim_pos - pos)
            if i == axis[1]: up_vec = -(pos - up_pos)
        else:
            if i == axis[0]: aim_vec = aim_pos - pos
            if i == axis[1]: up_vec = pos - up_pos

    aim_vec_norm = aim_vec.GetNormalized()
    third_vec_norm = aim_vec.Cross(up_vec).GetNormalized()
    up_vec_norm = aim_vec.Cross(third_vec_norm).GetNormalized()

    for i in axis:
        if i == axis[0]:
            if re.search(r"\A[-+]{,1}[x]\Z",i) != None: new_Ml.v1 = aim_vec_norm
            if re.search(r"\A[-+]{,1}[y]\Z",i) != None: new_Ml.v2 = aim_vec_norm
            if re.search(r"\A[-+]{,1}[z]\Z",i) != None: new_Ml.v3 = aim_vec_norm
        if i == axis[1]:
            if re.search(r"\A[-+]{,1}[x]\Z",i) != None: new_Ml.v1 = up_vec_norm
            if re.search(r"\A[-+]{,1}[y]\Z",i) != None: new_Ml.v2 = up_vec_norm
            if re.search(r"\A[-+]{,1}[z]\Z",i) != None: new_Ml.v3 = up_vec_norm

    new_str = ""
    for i in range(len(str(axis))):
        if re.search(r"[xyz]", str(axis)[i]) != None: new_str = new_str + str(axis)[i]
    
    if new_str[0] == new_str[1]: 
        print "Benutze zwei unterschiedliche Achsen!"
        return None    

    if new_str in ["zy","xz","yx"]:
        if re.search(r"\A[^x]{1,2}\Z", new_str) != None: new_Ml.v1 = third_vec_norm
        if re.search(r"\A[^y]{1,2}\Z", new_str) != None: new_Ml.v2 = third_vec_norm
        if re.search(r"\A[^z]{1,2}\Z", new_str) != None: new_Ml.v3 = third_vec_norm
    else:
        if re.search(r"\A[^x]{1,2}\Z", new_str) != None: new_Ml.v1 = -third_vec_norm
        if re.search(r"\A[^y]{1,2}\Z", new_str) != None: new_Ml.v2 = -third_vec_norm
        if re.search(r"\A[^z]{1,2}\Z", new_str) != None: new_Ml.v3 = -third_vec_norm

    return new_Ml

def Rel2Frz(obj):
    obj.SetFrozenPos(obj.GetRelPos())
    obj.SetFrozenRot(obj.GetRelRot())
    obj.SetRelPos(c4d.Vector(0,0,0))
    obj.SetRelRot(c4d.Vector(0,0,0))

def Pos2Off(obj, local_pos):
    if isinstance(obj, c4d.BaseObject): mg = obj.GetMg()
    if isinstance(obj, c4d.Matrix): mg = obj
    if isinstance(local_pos, c4d.Vector): pos = local_pos
    if isinstance(local_pos, c4d.Matrix): pos = local_pos.off
    if isinstance(local_pos, c4d.BaseObject): pos = local_pos.GetMg().off
    return mg.Mul(pos)

def Off2Pos(obj, global_pos):
    if isinstance(obj, c4d.BaseObject): mg = obj.GetMg()
    if isinstance(obj, c4d.Matrix): mg = obj
    if isinstance(global_pos, c4d.Vector): pos = global_pos
    if isinstance(global_pos, c4d.Matrix): pos = global_pos.off
    if isinstance(global_pos, c4d.BaseObject): pos = global_pos.GetMg().off
    return mg.__invert__().Mul(pos)

def GetCPolySelection(obj):
    polys = obj.GetAllPolygons()
    sel = obj.GetPolygonS().GetAll(obj.GetPolygonCount())
    selection = ()
    for i in range(len(sel)): 
        if sel[i] == 1: selection = selection + (({"id":i, "cp":polys[i]}),)
    if len(selection) == 0: return None
    else: return selection 

class Dlg(gui.GeDialog):
    GROUP = 10000
    STEXT_pos = 10001

    COMBO = 10002

    COMBO_poly = 10012
    Poly_stext = 10112
    Poly_combo = 10212
    Poly_straight = 10312
    Poly_smooth = 10412
    Poly_diagonal_A = 10512
    Poly_diagonal_B = 10612

    COMBO_point = 10022
    Point_stext_pos = 10122
    Point_pos_combo = 11122
    Point_pos_a = 12122
    Point_pos_b = 13122
    Point_pos_c = 14122
    Point_pos_d = 15122
    Point_stext_rot = 10222
    Point_rot_combo = 11222
    Point_rot_dia = 12222
    Point_rot_next = 13222
    Point_rot_prev = 14222

    COMBO_edge = 10032
    Edge_stext_pos = 10132
    Edge_pos_combo = 11132
    Edge_pos_a = 12132
    Edge_pos_b = 13132
    Edge_pos_c = 14132
    Edge_pos_d = 15132

    OK = 10004
    CANCEL = 10005
    combo_ = COMBO_poly

    poly_c = Poly_smooth
    point_pc = Point_pos_a
    point_rc = Point_rot_dia
    edge_c = Edge_pos_a 
    
    
    def CreateLayout(self):

        self.GroupBegin(self.GROUP, c4d.BFH_SCALEFIT, cols=9)
        self.AddStaticText(self.STEXT_pos, c4d.BFH_RIGHT, initw=120, name="      Polyaxis to")
        self.AddComboBox(self.COMBO, c4d.BFH_LEFT, initw=120)
        self.AddChild(self.COMBO, self.COMBO_poly, "POLYGON") 
        self.AddChild(self.COMBO, self.COMBO_point, "POINT") 
        self.AddChild(self.COMBO, self.COMBO_edge, "EDGE") 

        if self.combo_ == 10012: 

            self.AddStaticText(self.Poly_stext, c4d.BFH_RIGHT, initw=120, name="                Axis")
            self.AddComboBox(self.Poly_combo, c4d.BFH_LEFT, initw=120)   
            self.AddChild(self.Poly_combo, self.Poly_straight, "STRAIGHT") 
            self.AddChild(self.Poly_combo, self.Poly_smooth, "SMOOTH")
            self.AddChild(self.Poly_combo, self.Poly_diagonal_A, "DIAGONAL A") 
            self.AddChild(self.Poly_combo, self.Poly_diagonal_B, "DIAGONAL B")
            self.AddSeparatorH(120, c4d.BFH_SCALEFIT) 
            self.AddSeparatorH(120, c4d.BFH_SCALEFIT) 

        if self.combo_ == 10022:

            self.AddStaticText(self.Point_stext_pos, c4d.BFH_RIGHT, initw=120, name="       Position to")
            self.AddComboBox(self.Point_pos_combo, c4d.BFH_LEFT, initw=120)   
            self.AddChild(self.Point_pos_combo, self.Point_pos_a, "Point A") 
            self.AddChild(self.Point_pos_combo, self.Point_pos_b, "Point B") 
            self.AddChild(self.Point_pos_combo, self.Point_pos_c, "Point C") 
            self.AddChild(self.Point_pos_combo, self.Point_pos_d, "Point D") 

            self.AddStaticText(self.Point_stext_rot, c4d.BFH_RIGHT, initw=120, name="           Align to")
            self.AddComboBox(self.Point_rot_combo, c4d.BFH_LEFT, initw=120)   
            self.AddChild(self.Point_rot_combo, self.Point_rot_dia, "DIAGONAL") 
            self.AddChild(self.Point_rot_combo, self.Point_rot_next, "to NEXT Point") 
            self.AddChild(self.Point_rot_combo, self.Point_rot_prev, "to PREV Point")

        if self.combo_ == 10032:

            self.AddStaticText(self.Edge_stext_pos, c4d.BFH_RIGHT, initw=120, name="       Position to")
            self.AddComboBox(self.Edge_pos_combo, c4d.BFH_LEFT, initw=120)   
            self.AddChild(self.Edge_pos_combo, self.Edge_pos_a, "Edge AB") 
            self.AddChild(self.Edge_pos_combo, self.Edge_pos_b, "Edge BC") 
            self.AddChild(self.Edge_pos_combo, self.Edge_pos_c, "Edge CD") 
            self.AddChild(self.Edge_pos_combo, self.Edge_pos_d, "Edge DA")
            self.AddSeparatorH(120, c4d.BFH_SCALEFIT) 
            self.AddSeparatorH(120, c4d.BFH_SCALEFIT)  

        self.AddSeparatorH(120, c4d.BFH_SCALEFIT) 
        self.AddButton(self.OK, c4d.BFH_LEFT, name="OK")
        self.AddButton(self.CANCEL, c4d.BFH_LEFT, name="CANCEL")
        self.GroupEnd()
        return True

    def InitValues(self):
        self.SetLong(self.COMBO, self.combo_)
        self.SetLong(self.Poly_combo, self.poly_c)
        self.SetLong(self.Point_pos_combo, self.point_pc)
        self.SetLong(self.Point_rot_combo, self.point_rc)
        self.SetLong(self.Edge_pos_combo, self.edge_c)
        return True 

    def Command(self, id, msg):

        if id==self.COMBO:
            self.combo_ = self.GetLong(self.COMBO)
            self.LayoutFlushGroup(self.GROUP)
            self.CreateLayout()
            self.InitValues()
            self.LayoutChanged(self.GROUP)  

        if id==self.Poly_combo: self.poly_c = self.GetLong(self.Poly_combo)
        if id==self.Point_pos_combo: self.point_pc = self.GetLong(self.Point_pos_combo)
        if id==self.Point_rot_combo: self.point_rc = self.GetLong(self.Point_rot_combo)
        if id==self.Edge_pos_combo: self.edge_c = self.GetLong(self.Edge_pos_combo)
            
        if id==self.OK:
            c4d.StopAllThreads()
            obj = doc.GetActiveObject()
            sel = GetCPolySelection(obj)
            ax = doc.SearchObject("AX")
            
            if self.combo_ ==  self.COMBO_poly:
                if self.poly_c == self.Poly_straight: p_dict = ({"pos":("a","b","c","d"), "align":("b","a"), "up":("b","c")}, {"pos":("a","b","c"), "align":("b","a"), "up":("c","b")})
                elif self.poly_c == self.Poly_smooth: p_dict = ({"pos":("a","b","c","d"), "align":(("b","c"),("a","d")), "up":(("a","b"),("c","d"))}, {"pos":("a","b","c"), "align":("c",), "up":("a","b")})
                elif self.poly_c == self.Poly_diagonal_A: p_dict = ({"pos":("a","b","c","d"), "align":("a",), "up":("b","d")}, {"pos":("a","b","c"), "align":("a",), "up":("c","b")})
                elif self.poly_c == self.Poly_diagonal_B: p_dict = ({"pos":("a","b","c","d"), "align":("b",), "up":("c","a")}, {"pos":("a","b","c"), "align":("b",), "up":("c","a")})

            elif self.combo_ ==  self.COMBO_point:
                if self.point_pc == self.Point_pos_a:
                    if self.point_rc == self.Point_rot_dia: p_dict = ({"pos":("a",), "align":("c",), "up":("b","d")}, {"pos":("a",), "align":("b","c"), "up":("a","b","c")})
                    elif self.point_rc == self.Point_rot_next: p_dict = ({"pos":("a",), "align":("b",), "up":("c","d")}, {"pos":("a",), "align":("b",), "up":("c",)})
                    elif self.point_rc == self.Point_rot_prev: p_dict = ({"pos":("a",), "align":("d",), "up":("c","b")}, {"pos":("a",), "align":("c",), "up":("b",)})                         
                elif self.point_pc == self.Point_pos_b:
                    if self.point_rc == self.Point_rot_dia: p_dict = ({"pos":("b",), "align":("d",), "up":("c","a")}, {"pos":("b",), "align":("a","c"), "up":("a","b","c")})
                    elif self.point_rc == self.Point_rot_next: p_dict = ({"pos":("b",), "align":("c",), "up":("a","b","c","d")}, {"pos":("b",), "align":("c",), "up":("a",)})
                    elif self.point_rc == self.Point_rot_prev: p_dict = ({"pos":("b",), "align":("a",), "up":("a","b","c","d")}, {"pos":("b",), "align":("a",), "up":("c",)})
                elif self.point_pc == self.Point_pos_c:
                    if self.point_rc == self.Point_rot_dia: p_dict = ({"pos":("c",), "align":("a",), "up":("d","b")}, {"pos":("c",), "align":("a","b"), "up":("a","b","c")})
                    elif self.point_rc == self.Point_rot_next: p_dict = ({"pos":("c",), "align":("d",), "up":("a","b","c","d")}, {"pos":("c",), "align":("a",), "up":("b",)})
                    elif self.point_rc == self.Point_rot_prev: p_dict = ({"pos":("c",), "align":("b",), "up":("a","b","c","d")}, {"pos":("c",), "align":("b",), "up":("a",)})  
                elif self.point_pc == self.Point_pos_d:
                    if self.point_rc == self.Point_rot_dia: p_dict = ({"pos":("d",), "align":("b",), "up":("a","c")}, {"pos":("c",), "align":("a","b"), "up":("a","b","c")})
                    elif self.point_rc == self.Point_rot_next: p_dict = ({"pos":("d",), "align":("a",), "up":("a","b","c","d")}, {"pos":("c",), "align":("a",), "up":("b",)})
                    elif self.point_rc == self.Point_rot_prev: p_dict = ({"pos":("d",), "align":("c",), "up":("a","b","c","d")}, {"pos":("c",), "align":("b",), "up":("a",)})  

            elif self.combo_ ==  self.COMBO_edge:
                if self.edge_c == self.Edge_pos_a: p_dict = ({"pos":("a","b"), "align":("a",), "up":("a","b","c","d")}, {"pos":("a","b"), "align":("b",), "up":("c",)})
                elif self.edge_c == self.Edge_pos_b: p_dict = ({"pos":("b","c"), "align":("b",), "up":("a","b","c","d")}, {"pos":("b","c"), "align":("c",), "up":("a",)})
                elif self.edge_c == self.Edge_pos_c: p_dict = ({"pos":("c","d"), "align":("c",), "up":("a","b","c","d")}, {"pos":("c","a"), "align":("a",), "up":("b",)})
                elif self.edge_c == self.Edge_pos_d: p_dict = ({"pos":("d","a"), "align":("d",), "up":("a","b","c","d")}, {"pos":("c","a"), "align":("a",), "up":("b",)})

            aim_axis="x"
            up_axis="y" 
            if self.combo_ ==  self.COMBO_poly:
                if self.poly_c == self.Poly_diagonal_A or self.poly_c == self.Poly_diagonal_B or self.poly_c == self.Poly_straight:
                    aim_axis="y"
                    up_axis="x"  
            if self.combo_ ==  self.COMBO_point: 
                if self.point_rc == self.Point_rot_next or self.point_rc == self.Point_rot_prev:
                    aim_axis="y"
                    up_axis="x"  
            if self.combo_ ==  self.COMBO_edge:
                aim_axis="y"
                up_axis="x"

            all_poly = obj.GetAllPolygons()

            sel_id_tup = ()
            for i in sel: sel_id_tup = sel_id_tup + (i["id"],)

            new_poly_tup = ()    
            for i in range(len(all_poly)): 
                if i not in sel_id_tup: new_poly_tup = new_poly_tup + (all_poly[i],)

            new_obj = c4d.BaseObject(c4d.Opolygon)
            new_obj[c4d.ID_BASELIST_NAME]= obj.GetName() + ".1"
            new_obj.SetMg(obj.GetMg())
            new_obj.ResizeObject(obj.GetPointCount(), obj.GetPolygonCount()-len(sel))
            
            for i in range(obj.GetPointCount()): new_obj.SetPoint(i, obj.GetPoint(i)) 

            for i in range(len(new_poly_tup)): new_obj.SetPolygon(i, new_poly_tup[i])

            doc.InsertObject(new_obj, obj.GetUp(), obj)

            obj[c4d.ID_BASEOBJECT_VISIBILITY_EDITOR]=1

            for r_poly in sel:
                
                cp = r_poly["cp"]
                
                if "d" in sorted(cp.__str__()):
                    dic = p_dict[0] 
                    cp = {"a":cp.a, "b":cp.b, "c":cp.c, "d":cp.d}
                    pcnt = 4
                else: 
                    dic = p_dict[1] 
                    cp = {"a":cp.a, "b":cp.b, "c":cp.c} 
                    pcnt = 3                

                centre = c4d.Vector(0,0,0)
                for i in range(len(dic["pos"])): centre = centre + obj.GetPoint(cp[dic["pos"][i]])
                centre = centre/len(dic["pos"])
                
                if isinstance(dic["align"][0], tuple):
                    ad = c4d.Vector(0,0,0)
                    for i in range(len(dic["align"][0])): ad = ad + obj.GetPoint(cp[dic["align"][0][i]])  
                    bc = c4d.Vector(0,0,0)
                    for i in range(len(dic["align"][1])): bc = bc + obj.GetPoint(cp[dic["align"][1][i]])        
                    align = ((bc/2)-(ad/2))+centre
                else:
                    if len(dic["align"]) == 1: align = obj.GetPoint(cp[dic["align"][0]])                      
                    if len(dic["align"]) == 2: align = (obj.GetPoint(cp[dic["align"][1]])-obj.GetPoint(cp[dic["align"][0]])) + centre
                      

                if isinstance(dic["up"][0], tuple):
                    ad = c4d.Vector(0,0,0)
                    for i in range(len(dic["up"][0])): ad = ad + obj.GetPoint(cp[dic["up"][0][i]])  
                    bc = c4d.Vector(0,0,0)
                    for i in range(len(dic["up"][1])): bc = bc + obj.GetPoint(cp[dic["up"][1][i]])        
                    up = ((bc/2)-(ad/2)) + centre
                else:
                    if len(dic["up"]) == 1: up = obj.GetPoint(cp[dic["up"][0]]) 
                    if len(dic["up"]) == 2: up = (obj.GetPoint(cp[dic["up"][1]])-obj.GetPoint(cp[dic["up"][0]])) + centre                  
                    if len(dic["up"]) == 3: up = (obj.GetPoint(cp[dic["up"][0]])+obj.GetPoint(cp[dic["up"][1]])+obj.GetPoint(cp[dic["up"][2]]))/3                     
                    if len(dic["up"]) == 4: up = (obj.GetPoint(cp[dic["up"][0]])+obj.GetPoint(cp[dic["up"][1]])+obj.GetPoint(cp[dic["up"][2]])+obj.GetPoint(cp[dic["up"][3]]))/4
                      
                poly_obj = c4d.BaseObject(c4d.Opolygon)
                
                doc.InsertObject(poly_obj, new_obj, None)
                poly_obj[c4d.ID_BASELIST_NAME]=obj.GetName() + "_POLY_" + str(r_poly["id"])
                poly_obj.SetMl(AimAxis(centre, align, aim_axis, up, up_axis))
                Rel2Frz(poly_obj)
                
                new_a = Off2Pos(poly_obj, Pos2Off(obj, obj.GetPoint(cp["a"])))
                new_b = Off2Pos(poly_obj, Pos2Off(obj, obj.GetPoint(cp["b"])))
                new_c = Off2Pos(poly_obj, Pos2Off(obj, obj.GetPoint(cp["c"])))
                if pcnt == 4: new_d = Off2Pos(poly_obj, Pos2Off(obj, obj.GetPoint(cp["d"])))

                poly_obj.ResizeObject(pcnt, 1)

                poly_obj.SetPoint(0, new_a)
                poly_obj.SetPoint(1, new_b)
                poly_obj.SetPoint(2, new_c)
                if pcnt == 4: poly_obj.SetPoint(3, new_d)

                new_cpoly=c4d.CPolygon(0,1,2)
                if pcnt == 4: new_cpoly=c4d.CPolygon(0,1,2,3)
                poly_obj.SetPolygon(0, new_cpoly)
                  
            if gui.QuestionDialog("Original beibehalten?") == False:
                childs = ()
                child = obj.GetDown()
                while child != None:
                    childs = childs + (child.GetClone(),)
                    child = child.GetNext()
                for i in range(len(childs)-1,-1,-1):
                    doc.InsertObject(childs[i], new_obj, None)    
                obj.Remove()  

            self.Close() 

        if id==self.CANCEL:
            self.Close() 
        
        return True

def main(): 
    obj = doc.GetActiveObject()

    if obj == None:
        gui.MessageDialog("W\xe4hle genau ein Polygon-Objekt aus.")
        return False
    
    if obj.GetType() != 5100: 
        gui.MessageDialog('"{0}" ist kein Polygon-Objekt.'.format(obj.GetName()))
        return False 

    if GetCPolySelection(obj) == None: 
        gui.MessageDialog('Es sind keine Polygone ausgew\xe4hlt.'.format(obj.GetName()))
        return False
  
    dlg = Dlg()
    dlg.Open(c4d.DLG_TYPE_MODAL, xpos=550, ypos= 200, defaultw=800, defaulth=10)
    c4d.EventAdd()
   
if __name__=='__main__':
    main() 